/**
 * \file pid.h
 * \brief 简要介绍
 * \details 详细说明
 * \author lenotary
 * \version 1.0
 * \date 2021/9/13
 * \pre 先决条件。（有的话才添加。）
 * \bug 存在的bug。（有的话才添加，注明“还未发现”也可以。）
 * \warning 警告。（有的话才添加。）
 * \copyright 版权声明。（通常只写遵循什么协议，版权详细内容应放在LICENSE文件中，并且应该与LICENSE文件的内容统一，不能自相矛盾。）
 * \since 一些历史情况记录。（有的话才添加。）
 */


//
// Created by lenotary on 2021/9/13.
//

#ifndef SRC_PID_H
#define SRC_PID_H
#define LIMIT_MIN_MAX(x,min,max) (x) = (((x)<=(min))?(min):(((x)>=(max))?(max):(x)))
#include <iostream>

class Pid {
public:
    Pid(double kp, double ki, double kd, double iMax, double outMax);

    Pid();

    double PidCalc(int ref, int fdb);
private:
    double m_fKp_;
    double m_fKi_;
    double m_fKd_;
    double m_fInMax_;
    double m_fOutMax;

    double m_dRef_{};      // target value
    double m_dFdb_{};      // feedback value
    double m_dErr_[2]{};   // error and last error

    double m_dPOut_{};
    double m_dIOut_{};
    double m_dDOut_{};
    double m_DOutput_{};
};


#endif //SRC_PID_H
